; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Project name : DigitalClock - Clock
; File Name : DigitalClock - Clock.pb
; File version: 5.0.0
; Programming : OK
; Programmed by : StarBootics
; Date : 07-09-2016
; Last Update : 07-09-2016
; PureBasic code : V5.50
; Platform : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Clock
  
  Declare Initialize(P_CenterX.w, P_CenterY.w, P_LEDSize.w)
  Declare Reset()
  Declare Display()
  
EndDeclareModule

Module Clock
  
  Structure Instance
    
    Center.Vector2W::Vector2W
    Digit00.Vector2W::Vector2W[21]
    Digit01.Vector2W::Vector2W[21]
    Digit02.Vector2W::Vector2W[2]
    Digit03.Vector2W::Vector2W[21]
    Digit04.Vector2W::Vector2W[21]
    Digit05.Vector2W::Vector2W[2]
    Digit06.Vector2W::Vector2W[21]
    Digit07.Vector2W::Vector2W[21]
    SpriteID.l
    
  EndStructure
  
  Global Instance.Instance
  
  Macro IsNotBetween(Value, Lower, Upper)
    
    ((Value) < (Lower) Or (Value) > (Upper))
    
  EndMacro
  
  Procedure Initialize(P_CenterX.w, P_CenterY.w, P_LEDSize.w)
    
    Vector2W::Update(Instance\Center, P_CenterX, P_CenterY)
    
    Vector2W::Update(Instance\Digit00[00], -36, -8)
    Vector2W::Update(Instance\Digit00[01], -34, -8)
    Vector2W::Update(Instance\Digit00[02], -32, -8)
    
    Vector2W::Update(Instance\Digit00[03], -36, 0)
    Vector2W::Update(Instance\Digit00[04], -34, 0)
    Vector2W::Update(Instance\Digit00[05], -32, 0)
    
    Vector2W::Update(Instance\Digit00[06], -36, 8)
    Vector2W::Update(Instance\Digit00[07], -34, 8)
    Vector2W::Update(Instance\Digit00[08], -32, 8)
    
    Vector2W::Update(Instance\Digit00[09], -38, -6)
    Vector2W::Update(Instance\Digit00[10], -38, -4)
    Vector2W::Update(Instance\Digit00[11], -38, -2)
    
    Vector2W::Update(Instance\Digit00[12], -38, 2)
    Vector2W::Update(Instance\Digit00[13], -38, 4)
    Vector2W::Update(Instance\Digit00[14], -38, 6)
    
    Vector2W::Update(Instance\Digit00[15], -30, -6)
    Vector2W::Update(Instance\Digit00[16], -30, -4)
    Vector2W::Update(Instance\Digit00[17], -30, -2)
    
    Vector2W::Update(Instance\Digit00[18], -30, 2)
    Vector2W::Update(Instance\Digit00[19], -30, 4)
    Vector2W::Update(Instance\Digit00[20], -30, 6)
    
    For Index = 0 To 20
      Vector2W::SetI(Instance\Digit01[Index], Vector2W::GetI(Instance\Digit00[Index]) + 12)
      Vector2W::SetJ(Instance\Digit01[Index], Vector2W::GetJ(Instance\Digit00[Index]))
      Vector2W::SetI(Instance\Digit03[Index], Vector2W::GetI(Instance\Digit00[Index]) + 28)
      Vector2W::SetJ(Instance\Digit03[Index], Vector2W::GetJ(Instance\Digit00[Index]))
      Vector2W::SetI(Instance\Digit04[Index], Vector2W::GetI(Instance\Digit00[Index]) + 40)
      Vector2W::SetJ(Instance\Digit04[Index], Vector2W::GetJ(Instance\Digit00[Index]))
      Vector2W::SetI(Instance\Digit06[Index], Vector2W::GetI(Instance\Digit00[Index]) + 56)
      Vector2W::SetJ(Instance\Digit06[Index], Vector2W::GetJ(Instance\Digit00[Index]))
      Vector2W::SetI(Instance\Digit07[Index], Vector2W::GetI(Instance\Digit00[Index]) + 68)
      Vector2W::SetJ(Instance\Digit07[Index], Vector2W::GetJ(Instance\Digit00[Index]))
    Next
    
    Vector2W::Update(Instance\Digit02[00], -14, -4)
    Vector2W::Update(Instance\Digit02[01], -14, 4)
    
    Vector2W::Update(Instance\Digit05[00], 14, -4)
    Vector2W::Update(Instance\Digit05[01], 14, 4)
    
    Instance\SpriteID = Diode::Make(3, P_LEDSize)
    
    For Index = 0 To 20
      Vector2W::ProductByScalar(Instance\Digit00[Index], Instance\Digit00[Index], P_LEDSize)
      Vector2W::ProductByScalar(Instance\Digit01[Index], Instance\Digit01[Index], P_LEDSize)
      Vector2W::ProductByScalar(Instance\Digit03[Index], Instance\Digit03[Index], P_LEDSize)
      Vector2W::ProductByScalar(Instance\Digit04[Index], Instance\Digit04[Index], P_LEDSize)
      Vector2W::ProductByScalar(Instance\Digit06[Index], Instance\Digit06[Index], P_LEDSize)
      Vector2W::ProductByScalar(Instance\Digit07[Index], Instance\Digit07[Index], P_LEDSize)
      Vector2W::Minus(Instance\Digit00[Index], Instance\Center, Instance\Digit00[Index])
      Vector2W::Minus(Instance\Digit01[Index], Instance\Center, Instance\Digit01[Index])
      Vector2W::Minus(Instance\Digit03[Index], Instance\Center, Instance\Digit03[Index])
      Vector2W::Minus(Instance\Digit04[Index], Instance\Center, Instance\Digit04[Index])
      Vector2W::Minus(Instance\Digit06[Index], Instance\Center, Instance\Digit06[Index])
      Vector2W::Minus(Instance\Digit07[Index], Instance\Center, Instance\Digit07[Index])
    Next
    
    For Index = 0 To 1
      Vector2W::ProductByScalar(Instance\Digit02[Index], Instance\Digit02[Index], P_LEDSize)
      Vector2W::ProductByScalar(Instance\Digit05[Index], Instance\Digit05[Index], P_LEDSize)
      Vector2W::Minus(Instance\Digit02[Index], Instance\Center, Instance\Digit02[Index])
      Vector2W::Minus(Instance\Digit05[Index], Instance\Center, Instance\Digit05[Index])
    Next
    
  EndProcedure
  
  Procedure Reset()
    
    Vector2W::Reset(Instance\Center)
    
    For Digit00ID = 0 To 20
      Vector2W::Reset(Instance\Digit00[Digit00ID])
      Vector2W::Reset(Instance\Digit01[Digit00ID])
      Vector2W::Reset(Instance\Digit03[Digit00ID])
      Vector2W::Reset(Instance\Digit04[Digit00ID])
      Vector2W::Reset(Instance\Digit06[Digit00ID])
      Vector2W::Reset(Instance\Digit07[Digit00ID])
    Next
    
    For Digit02ID = 0 To 1
      Vector2W::Reset(Instance\Digit02[Digit02ID])
      Vector2W::Reset(Instance\Digit05[Digit02ID])
    Next
    
    If IsSprite(Instance\SpriteID)
      FreeSprite(Instance\SpriteID)
      Instance\SpriteID = 0
    EndIf
    
  EndProcedure
  
  Procedure Display()
    
    Hour01.b = LocalTime::GetHour() / 10
    Hour02.b = LocalTime::GetHour() - (10 * Hour01)
    
    Minute01.b = LocalTime::GetMinute() / 10
    Minute02.b = LocalTime::GetMinute() - (10 * Minute01)    
    
    Second01.b = LocalTime::GetSecond() / 10
    Second02.b = LocalTime::GetSecond() - (10 * Second01)
    
    Select Second01
        
      Case 0
        For Index = 0 To 20
          If IsNotBetween(Index, 3, 5)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit01[Index]), Vector2W::GetJ(Instance\Digit01[Index]))
          EndIf
        Next
        
      Case 1
        
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 8) And IsNotBetween(Index, 15, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit01[Index]), Vector2W::GetJ(Instance\Digit01[Index]))
          EndIf
        Next
        
      Case 2
        For Index = 0 To 20
          If IsNotBetween(Index, 9, 11) And IsNotBetween(Index, 18, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit01[Index]), Vector2W::GetJ(Instance\Digit01[Index]))
          EndIf
        Next
        
      Case 3
        For Index = 0 To 14
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit01[Index]), Vector2W::GetJ(Instance\Digit01[Index]))
        Next
        
      Case 4
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 2) And IsNotBetween(Index, 6, 8) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit01[Index]), Vector2W::GetJ(Instance\Digit01[Index]))
          EndIf
        Next
        
      Case 5
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit01[Index]), Vector2W::GetJ(Instance\Digit01[Index]))
          EndIf
        Next
        
      Case 6
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 14)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit01[Index]), Vector2W::GetJ(Instance\Digit01[Index]))
          EndIf
        Next
        
      Case 7
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 5) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit01[Index]), Vector2W::GetJ(Instance\Digit01[Index]))
          EndIf
        Next
        
      Case 8
        For Index = 0 To 20
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit01[Index]), Vector2W::GetJ(Instance\Digit01[Index]))
        Next
        
      Case 9
        For Index = 0 To 20
          If IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit01[Index]), Vector2W::GetJ(Instance\Digit01[Index]))
          EndIf
        Next
        
    EndSelect
    
    Select Second02
        
      Case 0
        For Index = 0 To 20
          If IsNotBetween(Index, 3, 5)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit00[Index]), Vector2W::GetJ(Instance\Digit00[Index]))
          EndIf
        Next
        
      Case 1
        
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 8) And IsNotBetween(Index, 15, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit00[Index]), Vector2W::GetJ(Instance\Digit00[Index]))
          EndIf
        Next
        
      Case 2
        For Index = 0 To 20
          If IsNotBetween(Index, 9, 11) And IsNotBetween(Index, 18, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit00[Index]), Vector2W::GetJ(Instance\Digit00[Index]))
          EndIf
        Next
        
      Case 3
        For Index = 0 To 14
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit00[Index]), Vector2W::GetJ(Instance\Digit00[Index]))
        Next
        
      Case 4
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 2) And IsNotBetween(Index, 6, 8) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit00[Index]), Vector2W::GetJ(Instance\Digit00[Index]))
          EndIf
        Next
        
      Case 5
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit00[Index]), Vector2W::GetJ(Instance\Digit00[Index]))
          EndIf
        Next
        
      Case 6
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 14)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit00[Index]), Vector2W::GetJ(Instance\Digit00[Index]))
          EndIf
        Next
        
      Case 7
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 5) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit00[Index]), Vector2W::GetJ(Instance\Digit00[Index]))
          EndIf
        Next
        
      Case 8
        For Index = 0 To 20
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit00[Index]), Vector2W::GetJ(Instance\Digit00[Index]))
        Next
        
      Case 9
        For Index = 0 To 20
          If IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit00[Index]), Vector2W::GetJ(Instance\Digit00[Index]))
          EndIf
        Next
        
    EndSelect
    
    Select Minute01
        
      Case 0
        For Index = 0 To 20
          If IsNotBetween(Index, 3, 5)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit04[Index]), Vector2W::GetJ(Instance\Digit04[Index]))
          EndIf
        Next
        
      Case 1
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 8) And IsNotBetween(Index, 15, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit04[Index]), Vector2W::GetJ(Instance\Digit04[Index]))
          EndIf
        Next
        
      Case 2
        For Index = 0 To 20
          If IsNotBetween(Index, 9, 11) And IsNotBetween(Index, 18, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit04[Index]), Vector2W::GetJ(Instance\Digit04[Index]))
          EndIf
        Next
        
      Case 3
        For Index = 0 To 14
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit04[Index]), Vector2W::GetJ(Instance\Digit04[Index]))
        Next
        
      Case 4
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 2) And IsNotBetween(Index, 6, 8) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit04[Index]), Vector2W::GetJ(Instance\Digit04[Index]))
          EndIf
        Next
        
      Case 5
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit04[Index]), Vector2W::GetJ(Instance\Digit04[Index]))
          EndIf
        Next
        
      Case 6
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 14)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit04[Index]), Vector2W::GetJ(Instance\Digit04[Index]))
          EndIf
        Next
        
      Case 7
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 5) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit04[Index]), Vector2W::GetJ(Instance\Digit04[Index]))
          EndIf
        Next
        
      Case 8
        For Index = 0 To 20
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit04[Index]), Vector2W::GetJ(Instance\Digit04[Index]))
        Next
        
      Case 9
        For Index = 0 To 20
          If IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit04[Index]), Vector2W::GetJ(Instance\Digit04[Index]))
          EndIf
        Next
        
    EndSelect
    
    Select Minute02
        
      Case 0
        For Index = 0 To 20
          If IsNotBetween(Index, 3, 5)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit03[Index]), Vector2W::GetJ(Instance\Digit03[Index]))
          EndIf
        Next
        
      Case 1
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 8) And IsNotBetween(Index, 15, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit03[Index]), Vector2W::GetJ(Instance\Digit03[Index]))
          EndIf
        Next
        
      Case 2
        For Index = 0 To 20
          If IsNotBetween(Index, 9, 11) And IsNotBetween(Index, 18, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit03[Index]), Vector2W::GetJ(Instance\Digit03[Index]))
          EndIf
        Next
        
      Case 3
        For Index = 0 To 14
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit03[Index]), Vector2W::GetJ(Instance\Digit03[Index]))
        Next
        
      Case 4
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 2) And IsNotBetween(Index, 6, 8) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit03[Index]), Vector2W::GetJ(Instance\Digit03[Index]))
          EndIf
        Next
        
      Case 5
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit03[Index]), Vector2W::GetJ(Instance\Digit03[Index]))
          EndIf
        Next
        
      Case 6
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 14)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit03[Index]), Vector2W::GetJ(Instance\Digit03[Index]))
          EndIf
        Next
        
      Case 7
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 5) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit03[Index]), Vector2W::GetJ(Instance\Digit03[Index]))
          EndIf
        Next
        
      Case 8
        For Index = 0 To 20
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit03[Index]), Vector2W::GetJ(Instance\Digit03[Index]))
        Next
        
      Case 9
        For Index = 0 To 20
          If IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit03[Index]), Vector2W::GetJ(Instance\Digit03[Index]))
          EndIf
        Next
        
    EndSelect
    
    Select Hour01
        
      Case 0
        For Index = 0 To 20
          If IsNotBetween(Index, 3, 5)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit07[Index]), Vector2W::GetJ(Instance\Digit07[Index]))
          EndIf
        Next
        
      Case 1
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 8) And IsNotBetween(Index, 15, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit07[Index]), Vector2W::GetJ(Instance\Digit07[Index]))
          EndIf
        Next
        
      Case 2
        For Index = 0 To 20
          If IsNotBetween(Index, 9, 11) And IsNotBetween(Index, 18, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit07[Index]), Vector2W::GetJ(Instance\Digit07[Index]))
          EndIf
        Next
        
      Case 3
        For Index = 0 To 14
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit07[Index]), Vector2W::GetJ(Instance\Digit07[Index]))
        Next
        
      Case 4
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 2) And IsNotBetween(Index, 6, 8) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit07[Index]), Vector2W::GetJ(Instance\Digit07[Index]))
          EndIf
        Next
        
      Case 5
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit07[Index]), Vector2W::GetJ(Instance\Digit07[Index]))
          EndIf
        Next
        
      Case 6
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 14)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit07[Index]), Vector2W::GetJ(Instance\Digit07[Index]))
          EndIf
        Next
        
      Case 7
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 5) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit07[Index]), Vector2W::GetJ(Instance\Digit07[Index]))
          EndIf
        Next
        
      Case 8
        For Index = 0 To 20
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit07[Index]), Vector2W::GetJ(Instance\Digit07[Index]))
        Next
        
      Case 9
        For Index = 0 To 20
          If IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit07[Index]), Vector2W::GetJ(Instance\Digit07[Index]))
          EndIf
        Next
        
    EndSelect
    
    Select Hour02
        
      Case 0
        For Index = 0 To 20
          If IsNotBetween(Index, 3, 5)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit06[Index]), Vector2W::GetJ(Instance\Digit06[Index]))
          EndIf
        Next
        
      Case 1
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 8) And IsNotBetween(Index, 15, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit06[Index]), Vector2W::GetJ(Instance\Digit06[Index]))
          EndIf
        Next
        
      Case 2
        For Index = 0 To 20
          If IsNotBetween(Index, 9, 11) And IsNotBetween(Index, 18, 20)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit06[Index]), Vector2W::GetJ(Instance\Digit06[Index]))
          EndIf
        Next
        
      Case 3
        For Index = 0 To 14
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit06[Index]), Vector2W::GetJ(Instance\Digit06[Index]))
        Next
        
      Case 4
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 2) And IsNotBetween(Index, 6, 8) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit06[Index]), Vector2W::GetJ(Instance\Digit06[Index]))
          EndIf
        Next
        
      Case 5
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit06[Index]), Vector2W::GetJ(Instance\Digit06[Index]))
          EndIf
        Next
        
      Case 6
        For Index = 0 To 20
          If IsNotBetween(Index, 12, 14)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit06[Index]), Vector2W::GetJ(Instance\Digit06[Index]))
          EndIf
        Next
        
      Case 7
        For Index = 0 To 20
          If IsNotBetween(Index, 0, 5) And IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit06[Index]), Vector2W::GetJ(Instance\Digit06[Index]))
          EndIf
        Next
        
      Case 8
        For Index = 0 To 20
          DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit06[Index]), Vector2W::GetJ(Instance\Digit06[Index]))
        Next
        
      Case 9
        For Index = 0 To 20
          If IsNotBetween(Index, 15, 17)
            DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit06[Index]), Vector2W::GetJ(Instance\Digit06[Index]))
          EndIf
        Next
        
    EndSelect 
    
    If LocalTime::GetSecond() % 2 = 0
      For Index = 0 To 1
        DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit02[Index]), Vector2W::GetJ(Instance\Digit02[Index]))
        DisplayTransparentSprite(Instance\SpriteID, Vector2W::GetI(Instance\Digit05[Index]), Vector2W::GetJ(Instance\Digit05[Index]))
      Next
    EndIf
    
  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<
; <<<<< END OF FILE <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.50 (Linux - x64)
; Folding = --
; EnableXP
; CompileSourceDirectory