; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Project name : DigitalClock - Dial
; File Name : DigitalClock - Dial.pb
; File version: 5.0.0
; Programming : OK
; Programmed by : StarBootics
; Date : 07-09-2016
; Last Update : 07-09-2016
; PureBasic code : V5.50
; Platform : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Dial

  Declare Initialize(P_CenterX.w, P_CenterY.w, P_LEDSize.w)
  Declare Reset()
  Declare Display()
  
EndDeclareModule

Module Dial

  Structure Instance

    Center.Vector2W::Vector2W
    SecondRadius.w
    MinuteRadius.w
    HourRadius.w
    SecondSpriteID.l
    MinuteSpriteID.l
    HourSpriteID.l
    Seconds.Vector2W::Vector2W[60]
    Minutes.Vector2W::Vector2W[60]
    Hours.Vector2W::Vector2W[24]

  EndStructure

  Global Instance.Instance
 
  Procedure Initialize(P_CenterX.w, P_CenterY.w, P_LEDSize.w)
    
    Vector2W::Update(Instance\Center, P_CenterX, P_CenterY)
    
    Instance\SecondRadius = P_CenterY + P_LEDSize - 1.75 * P_LEDSize
    Instance\MinuteRadius = Instance\SecondRadius - 1.75 * P_LEDSize
    Instance\HourRadius = Instance\MinuteRadius - 1.75 * P_LEDSize
    
    Instance\SecondSpriteID = Diode::Make(0, P_LEDSize)
    Instance\MinuteSpriteID = Diode::Make(1, P_LEDSize)
    Instance\HourSpriteID = Diode::Make(2, P_LEDSize)
    
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    ; On calcul toutes les positions pour les diodes puisque
    ; celles-ci demeurent les mmes pendant l'animation.
    
    For Index = 0 To 59
      
      Rad.d = (6 * Index) * (#PI / 180)
      
      Vector2W::SetI(Instance\Seconds[Index], Int(P_CenterX +  Instance\SecondRadius * Sin(Rad)) + P_LEDSize >> 1)
      Vector2W::SetJ(Instance\Seconds[Index], Int(P_CenterY -  Instance\SecondRadius * Cos(Rad)) + P_LEDSize >> 1)
      
      Vector2W::SetI(Instance\Minutes[Index], Int(P_CenterX +  Instance\MinuteRadius * Sin(Rad)) + P_LEDSize >> 1)
      Vector2W::SetJ(Instance\Minutes[Index], Int(P_CenterY -  Instance\MinuteRadius * Cos(Rad)) + P_LEDSize >> 1)
      
    Next
    
    For Index = 0 To 23
      
      Rad = (15 * Index) * (#PI / 180)
      
      Vector2W::SetI(Instance\Hours[Index], Int(P_CenterX +  Instance\HourRadius * Sin(Rad)) + P_LEDSize >> 1)
      Vector2W::SetJ(Instance\Hours[Index], Int(P_CenterY -  Instance\HourRadius * Cos(Rad)) + P_LEDSize >> 1)
      
    Next
    
  EndProcedure

  Procedure Reset()
    
    Vector2W::Reset(Instance\Center)
    Instance\SecondRadius = 0
    Instance\MinuteRadius = 0
    Instance\HourRadius = 0
    
    If IsSprite(Instance\SecondSpriteID)
      FreeSprite(Instance\SecondSpriteID)
      Instance\SecondSpriteID = 0
    EndIf
    
    If IsSprite(Instance\MinuteSpriteID)
      FreeSprite(Instance\MinuteSpriteID)
      Instance\MinuteSpriteID = 0
    EndIf
    
    If IsSprite(Instance\HourSpriteID)
      FreeSprite(Instance\HourSpriteID)
      Instance\HourSpriteID = 0
    EndIf

    For SecondsID = 0 To 59
      Vector2W::Reset(Instance\Seconds[SecondsID])
      Vector2W::Reset(Instance\Minutes[SecondsID])
    Next
    
    For HoursID = 0 To 23
      Vector2W::Reset(Instance\Hours[HoursID])
    Next
    
  EndProcedure
  
  Procedure Display()
    
    For Index = 0 To LocalTime::GetSecond()
      DisplayTransparentSprite(Instance\SecondSpriteID, Vector2W::GetI(Instance\Seconds[Index]), Vector2W::GetJ(Instance\Seconds[Index]))
    Next 
    
    For Index = 0 To LocalTime::GetMinute()
      DisplayTransparentSprite(Instance\MinuteSpriteID, Vector2W::GetI(Instance\Minutes[Index]), Vector2W::GetJ(Instance\Minutes[Index]))
    Next 
    
    For Index = 0 To LocalTime::GetHour()
      DisplayTransparentSprite(Instance\HourSpriteID, Vector2W::GetI(Instance\Hours[Index]), Vector2W::GetJ(Instance\Hours[Index]))
    Next 
    
  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<
; <<<<< END OF FILE <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.50 (Linux - x64)
; Folding = --
; EnableXP
; CompileSourceDirectory