; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Project name : DigitalClock - Starfield
; File Name : DigitalClock - Starfield.pb
; File version: 5.0.0
; Programming : OK
; Programmed by : StarBootics
; Date : 07-09-2016
; Last Update : 07-09-2016
; PureBasic code : V5.50
; Platform : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; This code was originally created by benny to create a starfield animation.
;
; See : http://www.purearea.net/pb/CodeArchiv/Graphics/Effects/Stars/SomeStars_with_Text.pb
;
; I deserve credit only to convert the original code into a Module.
;
; This code is free to be use where ever you like but you use it at your own risk.
;
; The author can in no way be held responsible for data loss, damage or other annoying 
; situations that may occur.
;
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule StarField

  Declare Initialize(P_ScreenW.w, P_ScreenH.w)
  Declare Reset()
  Declare Display()
  
EndDeclareModule

Module StarField

  #STAR3D_MAX = 2500

  Structure Star3D

    Speed.f
    Px.f
    Py.f
    Pz.f

  EndStructure

  Structure Instance

    ScreenW.w
    ScreenH.w
    SpeedMin.f
    Star3D.Star3D[#STAR3D_MAX]

  EndStructure

  Global Instance.Instance
  
  Macro RefreshStar3D(StarA, P_SpeedMin)
   
    StarA\Speed = P_SpeedMin + Random(Int(P_SpeedMin)) / 10.0
    StarA\Px = Random(3000) - 1500
    StarA\Py = Random(3000) - 1500
    StarA\Pz = 100 + Random(900)
    
  EndMacro

  Procedure Initialize(P_ScreenW.w, P_ScreenH.w)
    
    Instance\ScreenW = P_ScreenW
    Instance\ScreenH = P_ScreenH
    Instance\SpeedMin = 4.75
    
    For Star3DID = 0 To #STAR3D_MAX - 1
      RefreshStar3D(Instance\Star3D[Star3DID], Instance\SpeedMin)
    Next
    
  EndProcedure

  Procedure Reset()
    
    Instance\ScreenW = 0
    Instance\ScreenH = 0
    Instance\SpeedMin = 0.0
    
    For Star3DID = 0 To #STAR3D_MAX - 1
      Instance\Star3D[Star3DID]\Speed = 0.0
      Instance\Star3D[Star3DID]\Px = 0.0
      Instance\Star3D[Star3DID]\Py = 0.0
      Instance\Star3D[Star3DID]\Pz = 0.0
    Next
    
  EndProcedure
  
  Procedure Display()
    
    If StartDrawing(ScreenOutput())
      
      For Star3DID = 0 To #STAR3D_MAX - 1
        
        Instance\Star3D[Star3DID]\Pz = Instance\Star3D[Star3DID]\Pz - Instance\Star3D[Star3DID]\Speed 

        SX = Instance\Star3D[Star3DID]\Px / Instance\Star3D[Star3DID]\Pz * 100 + Instance\ScreenW / 2
        SY = Instance\Star3D[Star3DID]\Py / Instance\Star3D[Star3DID]\Pz * 100 + Instance\ScreenH / 2

        If SX <= 0 Or SY <= 0 Or SX >= Instance\ScreenW Or SY >= Instance\ScreenH Or Instance\Star3D[Star3DID]\Pz < 1 
          
          RefreshStar3D(Instance\Star3D[Star3DID], Instance\SpeedMin)
          
        Else 
          
          Couleur = Int(255 - Instance\Star3D[Star3DID]\Pz * (255/1000))
          Plot(SX, SY, RGB(Couleur,Couleur,Couleur)) 
          
        EndIf 
        
      Next 
      
      StopDrawing()
      
    EndIf 

  EndProcedure
  
EndModule

; <<<<<<<<<<<<<<<<<<<<<<<
; <<<<< END OF FILE <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.50 (Linux - x64)
; Folding = --
; EnableXP
; CompileSourceDirectory