; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Project name : Digital Clock - ToolBox File
; File Name : Digital Clock - ToolBox File.pb
; File version: 1.0.0
; Programming : OK
; Programmed by : StarBootics
; Date : 07-09-2016
; Last Update : 07-09-2016
; PureBasic code : V5.50
; Platform : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule LinearlySpacedValue
  
  Declare.f Float(IncrementID.l, IncrementMax.l, MinValue.f, MaxValue.f)

EndDeclareModule

Module LinearlySpacedValue
  
  Procedure.f Float(IncrementID.l, IncrementMax.l, MinValue.f, MaxValue.f)
    
    ProcedureReturn ((MinValue) + ((MaxValue) - (MinValue)) * ((IncrementID) / (IncrementMax)))
  EndProcedure

EndModule

DeclareModule FullScreen

  Declare.w GetWidth()
  Declare.w GetHeight()
  Declare.w GetDepth()
  Declare.s GetTitle()
  Declare Open(P_Title.s)
  Declare Close()

EndDeclareModule

Module FullScreen

  Structure Instance

    Width.w
    Height.w
    Depth.w
    Title.s

  EndStructure

  Global Instance.Instance

  Procedure.w GetWidth()

    ProcedureReturn Instance\Width
  EndProcedure

  Procedure.w GetHeight()

    ProcedureReturn Instance\Height
  EndProcedure

  Procedure.w GetDepth()

    ProcedureReturn Instance\Depth
  EndProcedure

  Procedure.s GetTitle()

    ProcedureReturn Instance\Title
  EndProcedure
 
  Procedure Open(P_Title.s)
    
    Instance\Title = P_Title
    
    If ExamineDesktops()
      Instance\Width = DesktopWidth(0)
      Instance\Height = DesktopHeight(0)
      Instance\Depth = DesktopDepth(0)  
    EndIf
      
    If InitKeyboard() = 0 Or InitSprite() = 0 Or InitMouse() = 0
      MessageRequester(Instance\Title + " - ERROR", "Can't initialize Keyboard, Sprite and/or Mouse !")
      End 
    EndIf 
    
    If OpenScreen(Instance\Width, Instance\Height, Instance\Depth, Instance\Title) = 0 
      MessageRequester(Instance\Title + " - ERROR", "Can't open screen !")
      End
    EndIf
    
  EndProcedure

  Procedure Close()
    
    Instance\Width = 0
    Instance\Height = 0
    Instance\Depth = 0
    Instance\Title = ""
    CloseScreen()
    
  EndProcedure

EndModule

DeclareModule LocalTime

  Declare.w GetYear()
  Declare.w GetMonth()
  Declare.w GetDay()
  Declare.w GetHour()
  Declare.w GetMinute()
  Declare.w GetSecond()
  Declare.w GetDayOfWeek()
  Declare.w GetWeekOfYear()
  Declare.l GetDate()
  Declare Initialize()
  Declare Reset()
  
EndDeclareModule

Module LocalTime

  Structure Instance

    Year.w
    Month.w
    Day.w
    Hour.w
    Minute.w
    Second.w
    DayOfWeek.w
    WeekOfYear.w
    Date.l

  EndStructure
  
  Global Instance.Instance
  
  Procedure WeekOfYear(Date.l)
    
    Compteur = Date(Year(Date),1,1,0,0,0) ;/ New year day
    Week = 0
    
    ;/ Goto 1st monday 
    
    Repeat
      
      If DayOfWeek(Compteur) = 1 
        Break 
      EndIf
      
      Compteur = AddDate(Compteur, #PB_Date_Day, 1)
      
    ForEver
    
    ;/ Add 1 week / Test if date is reach
    
    Repeat
      
      If Compteur > date 
        Break 
      EndIf
      
      Compteur = AddDate(Compteur, #PB_Date_Week, 1)
      Week + 1
      
    ForEver
    
    ProcedureReturn Week
  EndProcedure

  Procedure.w GetYear()

    ProcedureReturn Instance\Year
  EndProcedure

  Procedure.w GetMonth()

    ProcedureReturn Instance\Month
  EndProcedure

  Procedure.w GetDay()

    ProcedureReturn Instance\Day
  EndProcedure

  Procedure.w GetHour()

    ProcedureReturn Instance\Hour
  EndProcedure

  Procedure.w GetMinute()

    ProcedureReturn Instance\Minute
  EndProcedure

  Procedure.w GetSecond()

    ProcedureReturn Instance\Second
  EndProcedure

  Procedure.w GetDayOfWeek()

    ProcedureReturn Instance\DayOfWeek
  EndProcedure

  Procedure.w GetWeekOfYear()

    ProcedureReturn Instance\WeekOfYear
  EndProcedure

  Procedure.l GetDate()

    ProcedureReturn Instance\Date
  EndProcedure
  
  Procedure Initialize()
    
    Instance\Date = Date()
    
    Instance\Year = Year(Instance\Date)
    Instance\Month = Month(Instance\Date)
    Instance\Day = Day(Instance\Date)
    Instance\Hour = Hour(Instance\Date)
    Instance\Minute = Minute(Instance\Date)
    Instance\Second = Second(Instance\Date)
    Instance\DayOfWeek = DayOfWeek(Instance\Date)
    Instance\WeekOfYear = WeekOfYear(Instance\Date)
    
  EndProcedure

  Procedure Reset()
    
    Instance\Year = 0
    Instance\Month = 0
    Instance\Day = 0
    Instance\Hour = 0
    Instance\Minute = 0
    Instance\Second = 0
    Instance\DayOfWeek = 0
    Instance\WeekOfYear = 0
    Instance\Date = 0
    
  EndProcedure

EndModule

DeclareModule Vector2W

  Structure Vector2W

    I.w
    J.w

  EndStructure

  Declare.w GetI(*Vector2WA.Vector2W)
  Declare.w GetJ(*Vector2WA.Vector2W)
  Declare SetI(*Vector2WA.Vector2W, P_I.w)
  Declare SetJ(*Vector2WA.Vector2W, P_J.w)
  Declare Update(*Vector2WA.Vector2W, P_I.w, P_J.w)
  Declare Reset(*Vector2WA.Vector2W)
  Declare Plus(*Vector2WR.Vector2W, *Vector2WA.Vector2W, *Vector2WB.Vector2W)
  Declare Minus(*Vector2WR.Vector2W, *Vector2WA.Vector2W, *Vector2WB.Vector2W)
  Declare ProductByScalar(*Vector2WR.Vector2W, *Vector2WA.Vector2W, P_Scalar.w)

EndDeclareModule

Module Vector2W

  Procedure.w GetI(*Vector2WA.Vector2W)

    ProcedureReturn *Vector2WA\I
  EndProcedure

  Procedure.w GetJ(*Vector2WA.Vector2W)

    ProcedureReturn *Vector2WA\J
  EndProcedure

  Procedure SetI(*Vector2WA.Vector2W, P_I.w)

    *Vector2WA\I = P_I

  EndProcedure

  Procedure SetJ(*Vector2WA.Vector2W, P_J.w)

    *Vector2WA\J = P_J

  EndProcedure

  Procedure Update(*Vector2WA.Vector2W, P_I.w, P_J.w)

    *Vector2WA\I = P_I
    *Vector2WA\J = P_J

  EndProcedure

  Procedure Reset(*Vector2WA.Vector2W)
    
    *Vector2WA\I = 0
    *Vector2WA\J = 0
    
  EndProcedure

  Procedure Plus(*Vector2WR.Vector2W, *Vector2WA.Vector2W, *Vector2WB.Vector2W)

    *Vector2WR\I = *Vector2WA\I + *Vector2WB\I
    *Vector2WR\J = *Vector2WA\J + *Vector2WB\J

  EndProcedure

  Procedure Minus(*Vector2WR.Vector2W, *Vector2WA.Vector2W, *Vector2WB.Vector2W)

    *Vector2WR\I = *Vector2WA\I - *Vector2WB\I
    *Vector2WR\J = *Vector2WA\J - *Vector2WB\J

  EndProcedure

  Procedure ProductByScalar(*Vector2WR.Vector2W, *Vector2WA.Vector2W, P_Scalar.w)

    *Vector2WR\I = *Vector2WA\I * P_Scalar
    *Vector2WR\J = *Vector2WA\J * P_Scalar

  EndProcedure

EndModule

DeclareModule Diode
  
  Declare Make(DiodeID, P_Size.w)
  
EndDeclareModule

Module Diode
  
    Procedure Make(DiodeID, P_Size.w)
    
    PS = P_Size
    Size = PS << 1
    COLORV = 0 
    
    SpriteID = CreateSprite(#PB_Any, Size, Size)
    
    If IsSprite(SpriteID)
      
      TransparentSpriteColor(SpriteID, 0)
      
      If StartDrawing(SpriteOutput(SpriteID))
        
        Box(0,0, Size, Size, 0)
        Cxy = PS
        
        For Radius = 0 To PS
          
          Select DiodeID
              
            Case 0
              Color = RGB(COLORV, 000, 000)
              
            Case 1
              Color = RGB(000, 000, COLORV)
              
            Case 2
              Color = RGB(COLORV, COLORV >> 1, 000)
              
            Case 3
              Color = RGB(000, COLORV, 000)
              
            Case 4
              Color = RGB(COLORV >> 1, 000, COLORV)
              
          EndSelect
          
          Circle(Cxy, Cxy, PS - Radius, Color) 
          COLORV = Int(LinearlySpacedValue::Float(Radius, PS, 0, 255))
          
        Next
        
        StopDrawing() 
        
      EndIf
      
    EndIf
    
    ProcedureReturn SpriteID
  EndProcedure
  
EndModule
; <<<<<<<<<<<<<<<<<<<<<<<
; <<<<< END OF FILE <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.50 (Linux - x64)
; Folding = --------
; EnableXP
; CompileSourceDirectory